<?php



// QuickTeam 2.2 build:20090726



class cVIP

{



// --------



var $auth = false;

var $id = 0;

var $coockieconfirm = false;

var $username = 'Guest';

var $role = 'V';   // A=Administator,M=Moderator,U=User,V=Visitor



var $selfurl  = 'qte_index.php';

var $selfname = '';

var $exiturl  = 'qte_index.php';

var $exitname = 'Back';

var $css = array();



// --------

// CLASS CONSTRUCTOR

// Get authentified user info, if exists in session (or if coockie is set)



function cVIP()

{  

  if ( isset($_SESSION[QT.'_usr_auth']) ) {

  if ( $_SESSION[QT.'_usr_auth']=='yes' ) {



    $this->auth = true;

    if ( isset($_SESSION[QT.'_usr_id']) )       $this->id       = intval($_SESSION[QT.'_usr_id']);

    if ( isset($_SESSION[QT.'_usr_username']) ) $this->username = $_SESSION[QT.'_usr_username'];

    if ( isset($_SESSION[QT.'_usr_role']) )     $this->role     = $_SESSION[QT.'_usr_role'];



  }}



  // Remembered login



  if ( !$this->auth ) {

  if ( isset($_COOKIE[QT.'_cookname']) && isset($_COOKIE[QT.'_cookpass']) ) {

  

    global $oDB;

    $oDB->Query('SELECT * FROM '.TABUSER.' WHERE username="'.$_COOKIE[QT.'_cookname'].'" AND pwd="'.$_COOKIE[QT.'_cookpass'].'"');

    if ( $row = $oDB->Getrow() )

    {

      $this->auth = true;

      if ( isset($row['id']) )       $this->id       = intval($row['id']);

      if ( isset($row['username']) ) $this->username = $row['username'];

      if ( isset($row['role']) )     $this->role     = substr($row['role'],0,1);

      $this->Register();

      $this->coockieconfirm=true;

    }

      

  }}



  // Web Team Login



  if ( !$this->auth ) {

  if ( isset($_SESSION[QT]['login_qte_web']) ) {

  if ( !empty($_SESSION[QT]['login_qte_web']) ) {

    

    $this->LoginTeam('qte');



  }}}



  // QuickTicket login



  if ( !$this->auth ) {

  if ( isset($_SESSION[QT]['login_qti']) ) {

  if ( !empty($_SESSION[QT]['login_qti']) ) {

    

    $this->LoginTeam($_SESSION[QT]['login_qti']);



  }}}



  // QuickTalk login



  if ( !$this->auth ) {

  if ( isset($_SESSION[QT]['login_qtf']) ) {

  if ( !empty($_SESSION[QT]['login_qtf']) ) {

    

    $this->LoginTeam($_SESSION[QT]['login_qtf']);



  }}}



}



// --------



function IsStaff() { return ($this->role=='M' || $this->role=='A'); }



// --------



function IsPrivate($strFields,$strField,$id)

{

  // Check the privacy setting. $strField is in the list of private fields ($strFields)

  // Returns true/false if current user can see the private info

  if ( $this->IsStaff() ) return false;

  if ( $this->id==$id) return false;

  if ( strstr($strFields,$strField) ) return true;

  return false;

}



// --------

// DOLOGIN login and return extra info (fullname and coppa)



function Login( $strUsername='', $strPwd='', $bRemember=FALSE)

{

  global $oDB;

  $oDB->Query('SELECT count(*) as countid FROM '.TABUSER.' WHERE username="'.$strUsername.'" AND pwd="'.sha1($strPwd).'"');



  if ( $row = $oDB->Getrow() ) {

  if ( isset($row['countid']) ) {

  if ( $row['countid']=='1' ) {



    $this->auth = true;

    

    // Get user info

    $oDB->Query('SELECT id,role,firstname,lastname,children FROM '.TABUSER.' WHERE username="'.$strUsername.'" AND pwd="'.sha1($strPwd).'"');

    $row = $oDB->Getrow();

    $this->id = intval($row['id']);

    $this->username = $strUsername;

    $this->role = $row['role'];



    // Register VIP info in session

    $this->Register();

    if ( $bRemember )

    {

    setcookie(QT.'_cookname', htmlspecialchars($this->username,ENT_QUOTES), time()+60*60*24*100, '/');

    setcookie(QT.'_cookpass', sha1($strPwd), time()+60*60*24*100, '/');

    }

    

    if ( empty($row['firstname']) && empty($row['lastname']) ) { $str = $strUsername; } else { $str=$row['firstname'].' '.$row['lastname']; }

    return array('fullname'=>$str,'coppa'=>intval($row['children']));



  }}}



  return array('fullname'=>'','coppa'=>0);

}



// --------

// DOLOGINTEAM check weblogin/teamlogin and return extra info (fullname and coppa)



function LoginTeam($sid='qte')

{

  if ( isset($_SESSION[$sid.'_usr_auth']) && ( isset($_SESSION[$sid.'_usr_name']) || isset($_SESSION[$sid.'_usr_username']) ) ) {

  if ( $_SESSION[$sid.'_usr_auth']=='yes' ) {

    

    // check coherence: name must exist

    global $oDB;

    if ( isset($_SESSION[$sid.'_usr_name']) ) { $str = $_SESSION[$sid.'_usr_name']; } else { $str=$_SESSION[$sid.'_usr_username']; }

    $oDB->Query( 'SELECT count(*) as countid FROM '.TABUSER.' WHERE name="'.$str.'"' );

    

    if ( $row = $oDB->Getrow() ) {

    if ( isset($row['countid']) ) {

    if ( $row['countid']==1 ) {    



      $this->auth = true;



      // Get user info

      $oDB->Query('SELECT id,name,role,children,numpost,closed FROM '.TABUSER.' WHERE name="'.$str.'"');

      $row = $oDB->Getrow();

      $this->id = intval($row['id']);

      $this->username = $row['name'];

      $this->role = $row['role'];

      if ( !empty($row['numpost']) ) $this->numpost=intval($row['numpost']);



      // Register VIP info in session

      $this->Register();



      return array('fullname'=>$str,'coppa'=>intval($row['children']),'closed'=>intval($row['closed']));

        

    }}}

    

  }}

  

  return array('fullname'=>'','coppa'=>0,'closed'=>0);

}



// --------

// LOGOUT

// Remove session info (and coockie)



function Logout()

{  

  unset($_SESSION);

  session_destroy();  

  if ( isset($_COOKIE[QT.'_cookname']) ) setcookie(QT.'_cookname', '', time()+60*60*24*100, '/');

  if ( isset($_COOKIE[QT.'_cookpass']) ) setcookie(QT.'_cookpass', '', time()+60*60*24*100, '/');

}



// --------

// REGISTER



function Register()

{  

  $_SESSION[QT.'_usr_auth'] = 'yes';

  $_SESSION[QT.'_usr_id'] = $this->id;

  $_SESSION[QT.'_usr_username'] = $this->username;

  $_SESSION[QT.'_usr_role'] = $this->role;

}



// --------

// @$strTitle: title of the message box. When null or empty string, uses the page name ($this->selfname)

// @$strMessage: message body.

// @$strSkin: the skin folder

// @$intTime: the pause (in second) before redirecting to the exit page. Use 0 to NOT redirect



function EndMessage($strTitle,$strMessage='Access denied',$strSkin='skin/default',$intTime=0,$strWidth='300px',$strTitleId='msgboxtitle',$strBodyId='msgbox')

{

  $this->exiturl = str_replace('&amp;','&',$this->exiturl);

  if ( $strTitle=='0' )

  {

    if ( headers_sent() )

    {

    echo '<a href="',$this->exiturl,'">',$this->exitname,'</a><meta http-equiv="REFRESH" content="0;url=',$this->exiturl,'">';

    }

    else

    {

    header('Location: '.$this->exiturl);

    }

    exit;

  }

  if ( empty($strTitle) ) $strTitle = $this->selfname;

  HtmlHead('',$strSkin,'','',false);

  HtmlPageCtrl(0,'90%');

  HtmlMsg(0,$strWidth,$strTitleId,$strTitle,$strBodyId);

  echo $strMessage,'

  <p><a id="exiturl" href="',$this->exiturl,'">',$this->exitname,'</a></p>';

  HtmlMsg(1);

  HtmlPageCtrl(1);



  if ( $intTime>0 )

  {

  echo '

  <script type="text/javascript">

  <!--

  setTimeout(\'window.location=document.getElementById("exiturl").href\',',($intTime*1000),');

  -->

  </script>

  ';

  }

  echo '</body></html>';

  exit;

}



// --------

// $strCanView user role (V[i], U, M or A) that can access the page (i=public access level)

// $bStopOff stop when application off-line



function CanView($strCanView='V5',$bStopOff=true)

{  

  if ( $this->role=='A' ) { if ( $_SESSION[QT]['board_offline']=='1' ) echo '<p style="padding:4px;background-color:#ff0000;color:#ffffff">Board is offline but Administrators can make some actions.</p>'; return true; }

  if ( $strCanView=='U' && $this->role=='V') return false;

  if ( $strCanView=='M' && !$this->IsStaff() ) return false;  

  if ( $strCanView=='A' && $this->role!='A' ) return false;  

  if ( strlen($strCanView)==2 ) { $strPAL=substr($strCanView,-1,1); } else { $strPAL='5'; }

  if ( $this->role=='V' && $_SESSION[QT]['visitor_right']<$strPAL ) return false;

  if ( $_SESSION[QT]['board_offline']=='1' && $bStopOff ) return false;

  return true;

}





// --------



}

?>