<?php

// QuickTeam 2.2 build:20090726

function HtmlHead($strRoot='',$strSkin='',$arrCss='',$strHeadScript='',$bJava=true)
{

if ( empty($strSkin) ) $strSkin = $_SESSION[QT]['skin_dir'];
if ( !is_array($arrCss) ) $arrCss = array();

echo QTE_HTML_DTD,'
<html xmlns="http://www.w3.org/1999/xhtml" dir="',QTE_HTML_DIR,'" xml:lang="',QTE_HTML_LANG,'">
<head>
<title>',$_SESSION[QT]['site_name'],'</title>
<meta http-equiv="content-type" content="text/html; charset=',QTE_HTML_CHAR,'"/>
<link rel="shortcut icon" href="',$strRoot,$strSkin,'/qte_icon.ico"/>
<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/qte_main.css" title="cssmain"/>
';
foreach($arrCss as $strCss) {
switch($strCss) {
  case 'qte_contrast.css': echo '<link rel="alternate stylesheet" type="text/css" href="',$strRoot,'bin/css/qte_contrast.css" title="cssalternate"/>',"\n"; break;
  case 'qte_main2.css':    echo '<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/',$strCss,'" title="cssmain"/>',"\n"; break;
  default:
    if ( substr($strCss,0,6)=='[root]' )
    {
    echo '<link rel="stylesheet" type="text/css" href="',substr($strCss,6),'"/>',"\n";
    }
    else
    {
    echo '<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/',$strCss,'"/>',"\n";
    }
    break;
}}

if ( !empty($strHeadScript) ) echo $strHeadScript;
if ( $bJava )
{
echo '<script type="text/javascript">
<!--
';
include($strRoot.'bin/qte_j_common.js');
echo '
-->
</script>';
}

echo '</head>
';

}

// --------

function HtmlPageCtrl($intType=0,$strWidth='90%')
{

switch ($intType)
{
case 0: echo '
<!-- PAGE CONTROL -->
<div class="qte_page">
<table class="qte_page" width="',$strWidth,'" cellspacing="0" cellpadding="0"><tr class="qte_page"><td class="qte_page">
<!-- PAGE CONTROL -->  
';
break;
case 1: echo '
<!-- END PAGE CONTROL -->
</td></tr></table>
</div>
<!-- END PAGE CONTROL -->
';
break;
}

}

// --------

function HtmlBanner($intType=0,$strSkin=null,$strLogo=null,$strLangMenu=null)
{

if ( empty($strSkin) ) $strSkin=$_SESSION[QT]['skin_dir'];
if ( empty($strLogo) ) $strLogo='qte_logo.gif';

//if ( !file_exists($strSkin.'/'.$strLogo) ) { $strSkin='admin'; $strLogo='qte_logo.gif'; }

switch ($intType)
{
case 0: echo '
<!-- HEADER BANNER -->
<div class="banner"><div class="banner_in">
<table class="hidden" cellspacing="0"><tr class="hidden">
<td class="hidden" id="banner_zl"><img id="banner_logo" src="',$strSkin,'/',$strLogo,'" alt="',$_SESSION[QT]['site_name'],'" title="',$_SESSION[QT]['site_name'],'"/></td>
<td class="hidden" id="banner_zr">',$strLangMenu,'</td>
</tr></table></div></div>
<!-- END HEADER BANNER -->
';
break;
case 1: echo '
<!-- HEADER NOBANNER -->
<table class="hidden" cellspacing="0"><tr class="hidden">
<td class="hidden" id="nobanner_zl">&nbsp;</td>
<td class="hidden" id="nobanner_zr">&nbsp;',$strLangMenu,'</td>
</tr></table>
<!-- END HEADER NOBANNER -->
';
break;
case 2: echo '
<!-- HEADER BANNER -->
<div class="banner">
<div class="banner_in">
<img src="',$strSkin,'/',$strLogo,'" width="175" height="50" style="border-width:0" alt="QuickTeam" title="QuickTeam"/>
</div>
</div>
<!-- END HEADER BANNER -->
';
break;
}

}

// --------

function HtmlLettres($strGroup,$s,$str='All')
{
  global $oVIP;
  $strGroups = '<td class="lettres'.($strGroup=='all' ? ' active' : '').'" style="width:35px;">'.($strGroup=='all' ? $str : '<a class="lettres" href="'.$oVIP->selfurl.'?group=all'.(isset($s) ? '&amp;s='.$s : '').'">'.$str.'</a>' ).'</td>';
  for ($g='A';$g!='AA';$g++)
  {
  $strGroups .= '<td class="lettres'.($strGroup==$g ? ' active' : '').'" style="width:18px;">'.($strGroup==$g ? $g : '<a class="lettres" href="'.$oVIP->selfurl.'?group='.$g.(isset($s) ? '&amp;s='.$s : '').'">'.$g.'</a>' ).'</td>';
  }
  $strGroups .= '<td class="lettres'.($strGroup=='0' ? ' active' : '').'" style="width:18px;">'.($strGroup=='0' ? '#' : '<a class="lettres" href="'.$oVIP->selfurl.'?group=0'.(isset($s) ? '&amp;s='.$s : '').'">#</a>' ).'</td>';
  return $strGroups.'<td class="hidden">&nbsp;</td>'.N;
}

// --------

function HtmlPage($e=0)
{

global $oSYS,$oVIP,$L;
include('qte_p_header.php');

if ( $e==99 )
{
$strFile = Translate('sys_offline.txt'); if ( file_exists($strFile) ) { include($strFile); } else { echo Error(10); }
}
else
{
HtmlMsg(0); echo Error($e); HtmlMsg(1);
}

include('qte_p_footer.php');
exit;

}

// --------

function HtmlMsg($intType=0,$strWidth='',$strTitleId='',$strTitle='',$strBodyId='',$strBody='')
{

if ( empty($strWidth) ) $strWidth='350px';

switch ($intType)
{
case 0: echo '
<div class="msgbox" style="width:',$strWidth,'">
<div class="msgboxtitle"',(empty($strTitleId) ? '' : ' id="'.$strTitleId.'"'),'>',$strTitle,'</div>
<div class="msgboxbody"',(empty($strBodyId) ? '' : ' id="'.$strBodyId.'"'),'>',(empty($strBody) ? '' : $strBody),'
';
break;
case 1: echo '
</div>
</div>
';
break;
}

}

// --------

function HtmlTabs($arrTabs=array(0=>'Empty'),$strUrl='', $strCurrent='',$intMax=6,$bFirst=true,$bLast=true,$strWarning='Data not yet saved. Quit without saving?')
{

// tabx means the last tab (can be special due to popup)
// if defined, the class/style tab_on replaces the class/style tab (but you can cumulate the classes in the definition)
// if defined, the class/style tabx_on replaces the class/style tabx (but you can cumulate the styles in the definition)
// When strCurrent is defined, this tab will not be clickable
// $arrTabs can be an array of: strings, arrays, cTab


$iCurrent=1;
foreach(array_keys($arrTabs) as $strKey)
{
  if ($strKey==$strCurrent) break;
  $iCurrent++;
}

// check

if ( !is_array($arrTabs) ) die('HtmlTabs: Argument #1 must be an array');
if ( !empty($strUrl) ) { if ( !strstr($strUrl,'?') ) $strUrl .= '?'; }

// display

echo'
<!-- tab header begin -->
<table cellspacing="0" class="tab">
';

$strOuts=''; $strOut=''; $intRow=0; $intCol=0;
foreach($arrTabs as $strKey=>$oTab)
{
  if ( $intCol==0 )
  {
    $strOut = '<tr class="tab">'."\n";
    if ( $bFirst ) $strOut .= '<td class="tab '.($intRow==0 ? 'tab_begin' : 'tab_hidden').'">&nbsp;</td>'."\n";
    $intCol++;
  }
  if ( $intCol>0 )
  {
    $strTab = '';
    $strTabDesc = '';
    // extract name and description from the object in arrTabs: can be a string, an array or a cTab
    if ( is_string($oTab) )
    {
      $strTab = $oTab;
    }
    elseif ( is_array($oTab) )
    {
      if ( isset($oTab['tabdesc']) )
      {
        if ( !empty($oTab['tabdesc']) ) $strTabDesc = $oTab['tabdesc'];
      }
      if ( isset($oTab['tabname']) )
      {
        if ( !empty($oTab['tabname']) ) { $strTab=$oTab['tabname']; } else { $strTab=ObjTrans('tab',$strKey); }
      }
      else
      {
        $strTab=ObjTrans('tab',$strKey);
      }
    }
    elseif ( strtolower(get_class($oTab))=='ctab' )
    {
      $strTabDesc = $oTab->tabdesc;
      $strTab = $oTab->tabname; if ( empty($strTab) ) $strTab = $oTab->tabid;
    }
    else
    {
      die('HtmlTabs: Arg #1 must be an array of strings, arrays or cTab');
    }
    $strOut .= '<td class="tab tab_'.($strCurrent==$strKey ? 'on' : 'off').'_l">&nbsp;</td>';
    $strOut .= '<td class="tab tab_'.($strCurrent==$strKey ? 'on' : 'off').'_c">';
    if ( empty($strUrl) || $strCurrent==$strKey )
    {
    $strOut .=  $strTab;
    }
    else
    {
    $strOut .=  '<a class="tab" href="'.$strUrl.'&amp;tt='.$strKey.'"'.(empty($strTabDesc) ? '' : ' title="'.$strTabDesc.'"').' onclick="return warningedited(bEdited,\''.$strWarning.'\');">'.$strTab.'</a>';
    }
    $strOut .= '</td>';
    $strOut .= '<td class="tab tab_'.($strCurrent==$strKey ? 'on' : 'off').'_r">&nbsp;</td>'."\n";
    $intCol++; 
  }
  if ( $intCol>$intMax || $intCol>count($arrTabs) )
  {
    if ( $bLast ) $strOut .= '<td class="'.($intRow==0 ? 'tab tab_end' : 'hidden').'">&nbsp;</td>'."\n";
    $strOut .= '</tr>'."\n";
    $intCol=0;
    $strOuts = $strOut.$strOuts;
    $intRow++;
  }
}
if ( $intCol>0 )
{
  while($intCol<=$intMax) { $strOut .= '<td class="tab tab_a">&nbsp;</td>'; $intCol++; }
  if ( $bLast ) $strOut .= '<td class="tab'.($intRow==0 ? ' tab_end' : ' tab_hidden').'">&nbsp;</td>'."\n";
  $strOut .= '</tr>';
  $strOuts = $strOut.$strOuts;
}
echo $strOuts;

echo '
</table>
<!-- tab header end -->
';
}

// --------

function TableRows($s,$arrFLD,$bLink=true,$bMap,$qte_root='',$strSkin='default')
{
$intWhile=0;
$strAlt='1';
$arrSearch = array();
$arrUid = array();
global $oDB,$L,$arrExtData;
while($row=$oDB->Getrow())
{
  $oUser = new cUser($row);
  if ( in_array($oUser->id,$arrUid) ) continue; // prevent duplicate id (as from search query)
  $arrUid[]=$oUser->id;
  if ( isset($row['ufield']) ) $arrSearch['ufield']=$row['ufield'];
  if ( isset($row['ukey']) ) $arrSearch['ukey']=$row['ukey'];
  TableRow($arrFLD,$oUser,$bLink,$strAlt,$bMap,$qte_root,$strSkin,$arrSearch);
  if ( $strAlt=='1' ) { $strAlt='2'; } else { $strAlt='1'; }
  $intWhile++;
  //odbcbreak
  if ( $intWhile>=$_SESSION[QT]['items_per_page'] ) break;

  // map points
  if ( $bMap && isset($s) ) {
  if ( !empty($oUser->y) && !empty($oUser->x) ) {
    $str = QTconv(substr($oUser->fullname,0,50),'3',QTE_CONVERT_AMP);
    // add telephone and mail if not private
    if ( !strstr($oUser->privacy,"phones") ) $str .= '<br/>'.str_replace('; ','<br/>',$oUser->phones);
    $str .= '<br/>'.( !strstr($oUser->privacy,'emails') ? '<a class="gmap" href="mailto:'.$oUser->emails.'">'.$L['Email'].'</a> &middot; ' : '').'<a class="gmap" href="qte_usr.php?id='.$oUser->id.'">'.$L['map']['View_item'].'</a>';
    // add picture
    if ( !empty($oUser->picture) ) 
    {
    $str = '<table class="gmap"><tr><td>'.AsImg($oUser->picture,'',$oUser->lastname,'img_big').'</td><td>'.$str.'</td></tr></table>';
    }
    $oMapPoint = new cMapPoint( floatval($oUser->y),floatval($oUser->x),QTconv(substr($oUser->firstname.' '.$oUser->lastname,0,50),'-4'),$str );
    if ( isset($_SESSION[QT]['m_map'][$s]['icon']) )        $oMapPoint->icon = $_SESSION[QT]['m_map'][$s]['icon'];
    if ( isset($_SESSION[QT]['m_map'][$s]['shadow']) )      $oMapPoint->shadow = $_SESSION[QT]['m_map'][$s]['shadow'];
    if ( isset($_SESSION[QT]['m_map'][$s]['printicon']) )   $oMapPoint->printicon = $_SESSION[QT]['m_map'][$s]['printicon'];
    if ( isset($_SESSION[QT]['m_map'][$s]['printshadow']) ) $oMapPoint->printshadow = $_SESSION[QT]['m_map'][$s]['printshadow'];
    $arrExtData[intval($oUser->id)] = $oMapPoint;
  }}
}
}

// --------

function TableRow($arrFLD,$oUser,$bLink=true,$strAlt='1',$bMap=false,$qte_root='',$strSkin='default',$arrSearch=array())
{

// SETUP
  
global $oVIP,$oSYS,$L;

// coord
$strCoord='';
$strLatLon='';
if ( $bMap && !empty($oUser->y) && !empty($oUser->x) )
{
  $y = floatval($oUser->y);
  $x = floatval($oUser->x);
  $strCoord = '<a href="javascript:void(0)"'.(!$_SESSION[QT]['m_map_hidelist'] ? ' onclick="map.setCenter(new GLatLng('.$y.','.$x.')); return false;"' : '').' title="'.$L['Coord'].': '.round($y,8).','.round($x,8).'"><img class="ico" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_m_1.gif" alt="G" title="'.$L['Coord_latlon'].' '.QTdd2dms($y).','.QTdd2dms($x).'"/></a>';
  $strLatLon = QTdd2dms($y).($oSYS->output=='csv' ? ' ' : '<br/>').QTdd2dms($x);
  if ( empty($strCoord) ) $strCoord = '<img class="ico i_user" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_m_0.gif" alt="G" title="No coordinates"/>';
}
if ( $bMap && empty($strCoord) ) $strCoord = '<img class="ico i_user" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_m_0.gif" alt="G" title="No coordinates"/>';

// DISPLAY

// ----------
if( $oSYS->output=='screen' || $oSYS->output=='print' ) {
// ----------

  if ( $oSYS->output=='print' ) $bLink=false;

  echo '<tr class="data_t ',$strAlt,'">',N;

  // ::::::::::
  foreach($arrFLD as $strKey=>$oFLD) {
  // ::::::::::

  $str = '&nbsp;';
  $arrOptions = ReadValues($oFLD->desc);
  $strClass = ''; if ( isset($arrOptions['class']) ) $strClass = ' class="'.$arrOptions['class'].' td_t_'.$strAlt.'"';
  $strStyle = ''; if ( isset($arrOptions['style']) ) $strStyle = ' style="'.$arrOptions['style'].'"';
  
  switch ($strKey)
  {
  case 'status_i':  $str = AsImg($qte_root.$strSkin.'/'.$oSYS->statuses[$oUser->status]['icon'],$oUser->status,$oSYS->statuses[$oUser->status]['statusname'],'ico i_status'); break;
  case 'status':    $str = $oSYS->statuses[$oUser->status]['statusname']; $strStyle=' style="background-color:'.$oSYS->statuses[$oUser->status]['color'].'"';  break; 
  case 'role':      $str = $L['Userrole'][$oUser->role]; break; 
  case 'username':  $str = $oUser->$strKey; if ( $bLink ) $str = '<a'.$strClass.' href="'.$qte_root.'qte_usr.php?id='.$oUser->id.'" title="'.$oUser->fullname.'">'.$str.'</a>'; if ( !empty($strCoord) ) { $str .= ' '.$strCoord; $strCoord=''; } break; // strCoord is reset to be displayed only once.
  case 'firstname': $str = AsFormat($oUser->$strKey,$oFLD->format); if ( $bLink ) $str = '<a'.$strClass.' href="'.$qte_root.'qte_usr.php?id='.$oUser->id.'" title="'.$oUser->fullname.'">'.$str.'</a>'; if ( !empty($strCoord) ) { $str .= ' '.$strCoord; $strCoord=''; } break;
  case 'lastname':  $str = AsFormat($oUser->$strKey,$oFLD->format); if ( $bLink ) $str = '<a'.$strClass.' href="'.$qte_root.'qte_usr.php?id='.$oUser->id.'" title="'.$oUser->fullname.'">'.$str.'</a>'; if ( !empty($strCoord) ) { $str .= ' '.$strCoord; $strCoord=''; } break;
  case 'fullname':  $str = AsFormat($oUser->$strKey,$oFLD->format); if ( $bLink ) $str = '<a'.$strClass.' href="'.$qte_root.'qte_usr.php?id='.$oUser->id.'" title="'.$oUser->fullname.'">'.$str.'</a>'; if ( !empty($strCoord) ) { $str .= ' '.$strCoord; $strCoord=''; } break;
  case 'children':  $str = AsFormat(($oUser->coppa=='0' ? $L['N'] : $L['Y']),$oFLD->format); break;
  case 'picture':   $str = AsImg((empty($oUser->picture) ? '' : $qte_root.$oUser->picture),'',$oUser->fullname,'memberlist'.$_SESSION[QT]['viewmode'],'',($bLink ? $qte_root.'qte_usr.php?id='.$oUser->id : '')); break; 
  case 'birthdate': if ( !empty($oUser->$strKey) ) { if ( QTisvaliddate($oUser->$strKey,true,false,false) ) $str = QTdatestr($oUser->$strKey,'$','',false); } break;
  case 'teamdate1': if ( !empty($oUser->$strKey) ) { if ( QTisvaliddate($oUser->$strKey,true,true,false) ) $str = QTdatestr($oUser->$strKey,'$','',false); } break;
  case 'teamdate2': if ( !empty($oUser->$strKey) ) { if ( QTisvaliddate($oUser->$strKey,true,true,false) ) $str = QTdatestr($oUser->$strKey,'$','',false); } break;
  case 'registration': if ( !empty($oUser->$strKey) ) { if ( QTisvaliddate($oUser->$strKey,true,false,false) ) $str = QTdatestr($oUser->$strKey,'$','',false); } break;
  case 'address':   $str = implode('<br/>',AsList($oUser->address,$_SESSION[QT]['viewmode']=='C')); break;
  case 'phones':    $str = implode('<br/>',AsList($oUser->phones,$_SESSION[QT]['viewmode']=='C')); break;
  case 'coord':     $str = $strLatLon; break;
  case 'www':
    $arr = AsList($oUser->www,$_SESSION[QT]['viewmode']=='C');
    foreach($arr as $intKey=>$strValue) 
    {
      $arr[$intKey] = AsUrl(trim($strValue),$bLink,array('class'=>'small','target'=>'_blank','label'=>($oSYS->output=='print' ? $strValue : DropHttp($strValue))));
    }
    $str = implode('<br/>',$arr);
    break;         
  case 'emails':
    $arr = AsList($oUser->emails,$_SESSION[QT]['viewmode']=='C');
    foreach($arr as $intKey=>$strValue)
    {
      if ( $oSYS->output=='print' )
      {
      $arr[$intKey] = AsEmailText(trim($strValue),'mail_'.$oUser->id.'_'.$intKey,false,QTE_JAVA_MAIL,array('class'=>'small'));
      }
      else
      {
      $arr[$intKey] = AsEmailText(trim($strValue),'mail_'.$oUser->id.'_'.$intKey,$bLink,QTE_JAVA_MAIL,array('class'=>'small'));
      }
    }
    $str = implode('<br/>',$arr);
    break;         
  case 'emails_i':
    $arr = AsList($oUser->emails,$_SESSION[QT]['viewmode']=='C');
    foreach($arr as $intKey=>$strValue)
    {
      if ( $oSYS->output=='print' )
      {
      $arr[$intKey] = AsEmailText(trim($strValue),'mail_'.$oUser->id.'_'.$intKey,false,QTE_JAVA_MAIL,array('class'=>'small'));
      }
      else
      {
      $arr[$intKey] = AsEmailImage(trim($strValue),'mail_'.$oUser->id.'_'.$intKey,$bLink,QTE_JAVA_MAIL,array(),$qte_root);
      }
    }
    $str = implode(($oSYS->output=='print' ? '<br/>' : ' '),$arr);
    break;
  case 'ufield': $str = ObjTrans('field',$arrSearch['ufield']).'<br/><span class="small">'.strtolower($arrSearch['ukey']).'</span>'; break;
  default:       $str = AsFormat($oUser->$strKey,$oFLD->format); break;
  }

  echo '<td',$strClass,$strStyle,'>',($str==='' ? S : $str),'</td>'.N;
  
  // ::::::::::
  }
  // ::::::::::

  echo '</tr>',N;

// ----------
}  // end screen/print
// ----------

// ----------
if( $oSYS->output=='csv' ) {
// ----------

  global $strCSV;

  // ::::::::::
  foreach($arrFLD as $strKey=>$oFLD) {
  // ::::::::::

  switch($strKey)
  {
  case 'picture':  $strCSV .= ToCsv( (empty($oUser->picture) ? $L['N'] : $L['Y']) ); break;
  case 'status_i': $strCSV .= ToCsv( $oUser->status ); break;
  case 'status':   $strCSV .= ToCsv( $oSYS->statuses[$oUser->status]['statusname'] ); break;
  case 'role':     $strCSV .= ToCsv( $L['Userrole'][$oUser->role] ); break;
  case 'username': $strCSV .= ToCsv( AsFormat($oUser->$strKey,$oFLD->format) ); break;
  case 'firstname':$strCSV .= ToCsv( AsFormat($oUser->$strKey,$oFLD->format) ); break;
  case 'lastname': $strCSV .= ToCsv( AsFormat($oUser->$strKey,$oFLD->format) ); break;
  case 'fullname': $strCSV .= ToCsv( AsFormat($oUser->$strKey,$oFLD->format) ); break;
  case 'children': $strCSV .= ToCsv( ( $oUser->coppa=='0' ? AsFormat($L['N'],$oFLD->format) : AsFormat($L['Y'],$oFLD->format) ) ); break;
  case 'birthdate':if ( !empty($oUser->$strKey) ) { if ( QTisvaliddate($oUser->$strKey,true,false,false) ) $strCSV .= ToCsv( QTdatestr($oUser->$strKey,'$','',false) ); } break;
  case 'teamdate1':if ( !empty($oUser->$strKey) ) { if ( QTisvaliddate($oUser->$strKey,true,true,false) )  $strCSV .= ToCsv( QTdatestr($oUser->$strKey,'$','',false) ); } break;
  case 'teamdate2':if ( !empty($oUser->$strKey) ) { if ( QTisvaliddate($oUser->$strKey,true,true,false) )  $strCSV .= ToCsv( QTdatestr($oUser->$strKey,'$','',false) ); } break;
  case 'registration': if ( !empty($oUser->$strKey) ) { if ( QTisvaliddate($oUser->$strKey,true,false,false) ) $strCSV .= ToCsv( QTdatestr($oUser->$strKey,'$','',false) ); } break;
  case 'address':  $strCSV .= ToCsv( implode(' ',AsList($oUser->address,$_SESSION[QT]['viewmode']=='C')) ); break;         
  case 'www': $strCSV .= ToCsv( implode(' ',AsList($oUser->www,$_SESSION[QT]['viewmode']=='C')) ); break;
  case 'emails':   $strCSV .= ToCsv( $oUser->emails ); break;
  case 'emails_i': $strCSV .= ToCsv( $oUser->emails ); break;
  case 'phones':   $strCSV .= ToCsv( implode(' ',AsList($oUser->phones,$_SESSION[QT]['viewmode']=='C')) ); break;
  case 'coord':    $strCSV .= ToCsv( str_replace('&#176;','',$strLatLon) ); break;
  case 'ufield':   $strCSV .= ToCsv( ObjTrans('field',$row['ufield']).': '.strtolower($row['ukey']) ); break; 
  default:         $strCSV .= ToCsv( AsFormat($oUser->$strKey,$oFLD->format) ); break;
  }

  // ::::::::::
  }
  // ::::::::::

  // end with id (no ;)
  $strCSV .= $oUser->id."\r\n";

// ----------
}  // end csv
// ----------

}

?>